const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const obras = sequelize.define(
    'obras',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      nome_obra: {
        type: DataTypes.TEXT,
      },

      cidade: {
        type: DataTypes.TEXT,
      },

      estado: {
        type: DataTypes.TEXT,
      },

      descricao: {
        type: DataTypes.TEXT,
      },

      data_inicio: {
        type: DataTypes.DATEONLY,

        get: function () {
          return this.getDataValue('data_inicio')
            ? moment.utc(this.getDataValue('data_inicio')).format('YYYY-MM-DD')
            : null;
        },
      },

      data_previsao_termino: {
        type: DataTypes.DATEONLY,

        get: function () {
          return this.getDataValue('data_previsao_termino')
            ? moment
                .utc(this.getDataValue('data_previsao_termino'))
                .format('YYYY-MM-DD')
            : null;
        },
      },

      plantas_2d_georreferenciadas: {
        type: DataTypes.BOOLEAN,

        allowNull: false,
        defaultValue: false,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  obras.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    db.obras.hasMany(db.cameras_ptz, {
      as: 'cameras_ptz_obra',
      foreignKey: {
        name: 'obraId',
      },
      constraints: false,
    });

    db.obras.hasMany(db.equipes_trabalho, {
      as: 'equipes_trabalho_obra',
      foreignKey: {
        name: 'obraId',
      },
      constraints: false,
    });

    db.obras.hasMany(db.estrutura_projeto, {
      as: 'estrutura_projeto_obra',
      foreignKey: {
        name: 'obraId',
      },
      constraints: false,
    });

    db.obras.hasMany(db.etapas_ou_trechos, {
      as: 'etapas_ou_trechos_obra',
      foreignKey: {
        name: 'obraId',
      },
      constraints: false,
    });

    db.obras.hasMany(db.inspecao_aerea, {
      as: 'inspecao_aerea_obra',
      foreignKey: {
        name: 'obraId',
      },
      constraints: false,
    });

    db.obras.hasMany(db.memoriais_descritivos_asbuilt, {
      as: 'memoriais_descritivos_asbuilt_obra',
      foreignKey: {
        name: 'obraId',
      },
      constraints: false,
    });

    db.obras.hasMany(db.modelos_bim_asbuilt, {
      as: 'modelos_bim_asbuilt_obra',
      foreignKey: {
        name: 'obraId',
      },
      constraints: false,
    });

    db.obras.hasMany(db.plantas_asbuilt_2d, {
      as: 'plantas_asbuilt_2d_obra',
      foreignKey: {
        name: 'obraId',
      },
      constraints: false,
    });

    db.obras.hasMany(db.relatorio_andamento_atual, {
      as: 'relatorio_andamento_atual_obra',
      foreignKey: {
        name: 'obraId',
      },
      constraints: false,
    });

    db.obras.hasMany(db.relatorios_diarios, {
      as: 'relatorios_diarios_obra',
      foreignKey: {
        name: 'obraId',
      },
      constraints: false,
    });

    db.obras.hasMany(db.relatorios_mensais, {
      as: 'relatorios_mensais_obra',
      foreignKey: {
        name: 'obraId',
      },
      constraints: false,
    });

    db.obras.hasMany(db.relatorios_semanais, {
      as: 'relatorios_semanais_obra',
      foreignKey: {
        name: 'obraId',
      },
      constraints: false,
    });

    //end loop

    db.obras.belongsTo(db.clientes, {
      as: 'cliente',
      foreignKey: {
        name: 'clienteId',
      },
      constraints: false,
    });

    db.obras.belongsTo(db.clientes, {
      as: 'clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.obras.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.obras.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return obras;
};
